<?php

namespace Drupal\fox\Plugin\FoxCommand;

/**
 * PRINT fox command.
 *
 * @FoxCommand(
 *   id = "print",
 *   label = @Translation("Print variable. Usage: PRINT {variable}")
 * )
 */
class FoxCommandPrint extends FoxCommandBaseClass {

  /**
   * {@inheritdoc}
   */
  public function execute(array $params, array $variables): array {
    if (empty($params)) {
      return $this->errorReturn($this->t('Empty command parameter.'));
    }
    $param = reset($params);

    $parts = explode('.', $param);

    $name = reset($parts);
    if (!isset($variables[$name])) {
      return $this->errorReturn($this->t('No variable @var.', ['@var' => $name]));
    }

    $value = $variables[$name];
    unset($parts[0]);
    if (!empty($parts)) {
      foreach ($parts as $part) {
        if ($value) {
          $value = $value[$part] ?? NULL;
        }
      }
    }

    return [
      'message' => "$param=" . print_r($value, TRUE),
      'hide_variables' => TRUE,
    ];
  }

}
